// ThreadProbeDll.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "ThreadProbeDll.h"
#include "ThreadFunctions.h"

void DisplayLastErrorMessage(void);

//
//  We need the Critical Section for safely access data
//
CRITICAL_SECTION CriticalSection;
//
//  The main DLL entry point  ///////////////////////////////////////////////////
//
BOOL APIENTRY DllMain(HANDLE hModule,DWORD  ul_reason_for_call,LPVOID lpReserved)
{
  switch (ul_reason_for_call) {
    case DLL_PROCESS_ATTACH:
      InitializeCriticalSection(&CriticalSection);
      WorkThread = CreateThread(NULL,0,WorkThreadLoop,0,0,NULL);
      if(WorkThread == NULL) {
        DisplayLastErrorMessage();	// Work thread NOT created!
      }
      break;
    case DLL_PROCESS_DETACH:
      if(WorkThread != NULL) {
        ThreadStopFlag = TRUE;	// Stop working thread
        Sleep(200);		// Give time for thread exiting
        CloseHandle(WorkThread);
      }
      DeleteCriticalSection(&CriticalSection);
      break;
    case DLL_THREAD_ATTACH:
    case DLL_THREAD_DETACH:
      break;
  }
  return TRUE;
}

// This is an example of an exported functions

THREADPROBEDLL_API void ThreadProbeDll_Serial_flush(void)
{
  Serial_flush();
}

THREADPROBEDLL_API BOOL ThreadProbeDll_Serial_empty(void)
{
  return Serial_empty();
}

THREADPROBEDLL_API int  ThreadProbeDll_Serial_getc(void)
{
  return Serial_getc();
}
/////////////////////////////////////////////////////////////////////////////
//
//  Utility function for displaying Last Error message
//
void DisplayLastErrorMessage(void)
{
  LPVOID lpMsgBuf;

  FormatMessage( 
    FORMAT_MESSAGE_ALLOCATE_BUFFER | 
    FORMAT_MESSAGE_FROM_SYSTEM | 
    FORMAT_MESSAGE_IGNORE_INSERTS,
    NULL,
    GetLastError(),
    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
    (LPTSTR) &lpMsgBuf,
    0,
    NULL 
  );
  // Display the string.
  MessageBox(NULL,(LPCTSTR)lpMsgBuf,"LastError",MB_OK);
  // Free the buffer.
  LocalFree( lpMsgBuf );
}
